Components.utils.import("resource://another-profiler/livingObjects.js");

function returnToLists() {
  $("#view-lists").show();
  $("#view-results").hide();
}

function profileFunction() {
  var namedObjects=getNamedObjects();
  
  // namedObjects["parent"] is null ... why ?!
  var parent;
  for(var i in namedObjects) {
    if (i=="parent") {
      parent = parseInt(namedObjects[i]);
    } else if (i=="objectId") {
      parent = getObjectProperty(parseInt(namedObjects[i]),"id").id;
    }
  }
  
  // Remove web content windows js wrapper
  var inf = getObjectInfo(parent);
  if (inf && inf.nativeClass=="XPCSafeJSObjectWrapper") {
    parent = inf.wrappedObject;
  }
  
  var children = {};
  
  // Check every JS object
  var table = getObjectTable();
  for(var i in table) {
    var info = getObjectInfo(parseInt(i));
    
    // Search if this one is related to the selected parent
    // ie walk throught all parents in order to find if the current object is a descendant of selected parent
    if ( info.parent != parent ) {
      var parentMatch = false;
      var p = info.parent;
      while(true) {
        var subinfo = getObjectInfo(p);
        if (!subinfo) break;
        
        if ( subinfo.id == parent || subinfo.parent == parent ) {
          // Answer= Yes
          parentMatch = true;
          break;
        }
        
        // Walk throught encapsulated objects
        if (subinfo.outerObject && subinfo.outerObject!=p) {
          p = subinfo.outerObject;
          continue;
        }
        
        p = subinfo.parent;
      }
      // Answer= Yes
      if (!parentMatch) continue;
    }
    
    if (!children[info.nativeClass])
      children[info.nativeClass] = 0;
    children[info.nativeClass]++;
  }
  
  return JSON.stringify(children);
}

function profile(info) {
  var factory = Components.classes["@labs.mozilla.com/jetpackdi;1"]
               .createInstance(Components.interfaces.nsIJetpack);
  var endpoint = factory.get();
  var namedObjects = {};
  if (typeof info.object=="number")
    namedObjects = {objectId:{id:info.object}};
  else
    namedObjects = {parent:info.object.wrappedJSObject?info.object.wrappedJSObject:info.object};
  var json = endpoint.profileMemory(profileFunction.toSource()+"\nprofileFunction()", "profile.js", 1, namedObjects);
  var children = JSON.parse(json);
  
  $("#view-lists").hide();
  $("#view-results").show();
  $("#results-parent").text(info.name+(info.href?" - "+info.href:""));
  $("#list-classname").html("");
  var list=[];
  for(var classname in children) {
    list.push({classname:classname, number: children[classname]});
  }
  list.sort(function (a,b){return a.number<b.number;});
  list.forEach(function (item) {
    var li = $("<li></li>");
    li.append($('<span class="class-count"></span>').text(item.number));
    li.append($('<span class="class-name"></span>').text(item.classname));
    $("#list-classname").append(li);
  });
  
}

function updateWindows() {
  $("#list-windows").html("");
  var windows = getAllWindows();
  function addAWindow(container,info) {
    var item = $("<a></a>");
    item.addClass("link");
    item.text((info.name?info.name+" -> ":"")+info.href);
    item.click(function () {profile(info);});
    var li = $("<li></li>");
    li.append(item);
    if (info.children && info.children.length>0) {
      var sublist = $("<ul></ul>");
      li.append(sublist);
      info.children.forEach( function (subinfo) {
        addAWindow(sublist,subinfo);
      });
    }
    container.append(li);
  }
  windows.forEach( function (info) {
    addAWindow($("#list-windows"),info);
  });
}

function updateXPCOMs() {
  $("#list-xpcoms").html("");
  var xpcoms = getAllXPCOMServices();
  xpcoms.sort(function(a,b) {return a.name.toLowerCase()>b.name.toLowerCase();});
  xpcoms.forEach( function (info) {
    var item = $("<a></a>");
    item.addClass("link");
    item.text(info.name);
    item.click(function () {profile(info);});
    $("#list-xpcoms").append($("<li></li>").append(item));
  });
}

function updateModules() {
  $("#list-modules").html("");
  var modules = getAllJSModules();
  modules.sort(function(a,b) {return a.name.toLowerCase()>b.name.toLowerCase();});
  modules.forEach( function (info) {
    var item = $("<a></a>");
    item.addClass("link");
    item.text(info.name);
    item.click(function () {profile(info);});
    $("#list-modules").append($("<li></li>").append(item));
  });
}



$(window).ready(function () {
  updateWindows();
  updateXPCOMs();
  updateModules();
});